ace.define("ace/mode/prql_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(o,p,x){"use strict";var f=o("../lib/oop"),d=o("./text_highlight_rules").TextHighlightRules,u=function(){var e=["bool","int","int8","int16","int32","int64","float","text","set"].join("|"),n=this.createKeywordMapper({"constant.language":"null","constant.language.boolean":"true|false",keyword:"let|into|case|prql|type|module|internal","storage.type":"let|func","support.function":"min|max|sum|average|stddev|every|any|concat_array|count|lag|lead|first|last|rank|rank_dense|row_number|round|as|in|tuple_every|tuple_map|tuple_zip|_eq|_is_null|from_text|lower|upper|read_parquet|read_csv","support.type":e},"identifier"),t=/\\(\d+|['"\\&bfnrt]|u[0-9a-fA-F]{4})/,a=/[A-Za-z_][a-z_A-Z0-9]/.source,r="[\\u202A\\u202B\\u202D\\u202E\\u2066\\u2067\\u2068\\u202C\\u2069]";this.$rules={start:[{token:"string.start",regex:'s?"',next:"string"},{token:"string.start",regex:'f"',next:"fstring"},{token:"string.start",regex:'r"',next:"rstring"},{token:"string",start:"'",end:"'"},{token:"string.character",regex:"'(?:"+t.source+"|.)'?"},{token:"constant.language",regex:"^"+a+"*"},{token:"constant.numeric",regex:/0(?:[xX][0-9a-fA-F]+|[oO][0-7]+|[bB][01]+)\b/},{token:"constant.numeric",regex:/(?:\d\d*(?:\.\d*)?|\.\d+)(?:[eE][+-]?\d+\b)?/},{token:"comment.block",regex:"#!.*"},{token:"comment.line",regex:"#.*"},{token:"keyword.operator",regex:/\|\s*/,next:"pipe"},{token:"keyword.operator",regex:/->|=>|==|!=|>=|<=|~=|&&|\|\||\?\?|\/\/|@/},{token:"invalid.illegal",regex:r},{token:"punctuation.operator",regex:/[,`]/},{token:n,regex:"[\\w\\xff-\\u218e\\u2455-\\uffff]+\\b"},{token:"paren.lparen",regex:/[\[({]/},{token:"paren.rparen",regex:/[\])}]/}],pipe:[{token:"constant.language",regex:a+"*",next:"pop"},{token:"error",regex:"",next:"pop"}],string:[{token:"constant.character.escape",regex:t},{token:"text",regex:/\\(\s|$)/,next:"stringGap"},{token:"string.end",regex:'"',next:"start"},{token:"invalid.illegal",regex:r},{defaultToken:"string"}],stringGap:[{token:"text",regex:/\\/,next:"string"},{token:"error",regex:"",next:"start"}],fstring:[{token:"constant.character.escape",regex:t},{token:"string.end",regex:'"',next:"start"},{token:"invalid.illegal",regex:r},{token:"paren.lparen",regex:"{",push:"fstringParenRules"},{token:"invalid.illegal",regex:r},{defaultToken:"string"}],fstringParenRules:[{token:"constant.language",regex:"^"+a+"*"},{token:"paren.rparen",regex:"}",next:"pop"}],rstring:[{token:"string.end",regex:'"',next:"start"},{token:"invalid.illegal",regex:r},{defaultToken:"string"}]},this.normalizeRules()};f.inherits(u,d),p.PrqlHighlightRules=u}),ace.define("ace/mode/folding/cstyle",["require","exports","module","ace/lib/oop","ace/range","ace/mode/folding/fold_mode"],function(o,p,x){"use strict";var f=o("../../lib/oop"),d=o("../../range").Range,u=o("./fold_mode").FoldMode,c=p.FoldMode=function(e){e&&(this.foldingStartMarker=new RegExp(this.foldingStartMarker.source.replace(/\|[^|]*?$/,"|"+e.start)),this.foldingStopMarker=new RegExp(this.foldingStopMarker.source.replace(/\|[^|]*?$/,"|"+e.end)))};f.inherits(c,u),function(){this.foldingStartMarker=/([\{\[\(])[^\}\]\)]*$|^\s*(\/\*)/,this.foldingStopMarker=/^[^\[\{\(]*([\}\]\)])|^[\s\*]*(\*\/)/,this.singleLineBlockCommentRe=/^\s*(\/\*).*\*\/\s*$/,this.tripleStarBlockCommentRe=/^\s*(\/\*\*\*).*\*\/\s*$/,this.startRegionRe=/^\s*(\/\*|\/\/)#?region\b/,this._getFoldWidgetBase=this.getFoldWidget,this.getFoldWidget=function(e,n,t){var a=e.getLine(t);if(this.singleLineBlockCommentRe.test(a)&&!this.startRegionRe.test(a)&&!this.tripleStarBlockCommentRe.test(a))return"";var r=this._getFoldWidgetBase(e,n,t);return!r&&this.startRegionRe.test(a)?"start":r},this.getFoldWidgetRange=function(e,n,t,a){var i,r=e.getLine(t);if(this.startRegionRe.test(r))return this.getCommentRegionBlock(e,r,t);if(i=r.match(this.foldingStartMarker)){var g=i.index;if(i[1])return this.openingBracketBlock(e,i[1],t,g);var l=e.getCommentFoldRange(t,g+i[0].length,1);return l&&!l.isMultiLine()&&(a?l=this.getSectionRange(e,t):"all"!=n&&(l=null)),l}return"markbegin"!==n&&(i=r.match(this.foldingStopMarker))?(g=i.index+i[0].length,i[1]?this.closingBracketBlock(e,i[1],t,g):e.getCommentFoldRange(t,g,-1)):void 0},this.getSectionRange=function(e,n){for(var t=e.getLine(n),a=t.search(/\S/),r=n,g=t.length,l=n+=1,i=e.getLength();++n<i;){var h=(t=e.getLine(n)).search(/\S/);if(-1!==h){if(a>h)break;var s=this.getFoldWidgetRange(e,"all",n);if(s){if(s.start.row<=r)break;if(s.isMultiLine())n=s.end.row;else if(a==h)break}l=n}}return new d(r,g,l,e.getLine(l).length)},this.getCommentRegionBlock=function(e,n,t){for(var a=n.search(/\s*$/),r=e.getLength(),g=t,l=/^\s*(?:\/\*|\/\/|--)#?(end)?region\b/,i=1;++t<r;){n=e.getLine(t);var h=l.exec(n);if(h&&(h[1]?i--:i++,!i))break}if(t>g)return new d(g,a,t,n.length)}}.call(c.prototype)}),ace.define("ace/mode/prql",["require","exports","module","ace/lib/oop","ace/mode/text","ace/mode/prql_highlight_rules","ace/mode/folding/cstyle"],function(o,p,x){"use strict";var f=o("../lib/oop"),d=o("./text").Mode,u=o("./prql_highlight_rules").PrqlHighlightRules,c=o("./folding/cstyle").FoldMode,e=function(){this.HighlightRules=u,this.foldingRules=new c,this.$behaviour=this.$defaultBehaviour};f.inherits(e,d),function(){this.lineCommentStart="#",this.$id="ace/mode/prql"}.call(e.prototype),p.Mode=e}),ace.require(["ace/mode/prql"],function(o){"object"==typeof module&&"object"==typeof exports&&module&&(module.exports=o)});