ace.define("ace/mode/coffee_highlight_rules",["require","exports","module","ace/lib/oop","ace/mode/text_highlight_rules"],function(o,x,k){"use strict";var p=o("../lib/oop"),f=o("./text_highlight_rules").TextHighlightRules;function c(){var g="[$A-Za-z_\\x7f-\\uffff][$\\w\\x7f-\\uffff]*",e="case|const|function|var|void|with|enum|implements|interface|let|package|private|protected|public|static",r=this.createKeywordMapper({keyword:"this|throw|then|try|typeof|super|switch|return|break|by|continue|catch|class|in|instanceof|is|isnt|if|else|extends|for|own|finally|function|while|when|new|no|not|delete|debugger|do|loop|of|off|or|on|unless|until|and|yes|yield|export|import|default","constant.language":"true|false|null|undefined|NaN|Infinity","invalid.illegal":e,"language.support.class":"Array|Boolean|Date|Function|Number|Object|RegExp|ReferenceError|String|Error|EvalError|InternalError|RangeError|ReferenceError|StopIteration|SyntaxError|TypeError|URIError|ArrayBuffer|Float32Array|Float64Array|Int16Array|Int32Array|Int8Array|Uint16Array|Uint32Array|Uint8Array|Uint8ClampedArray","language.support.function":"Math|JSON|isNaN|isFinite|parseInt|parseFloat|encodeURI|encodeURIComponent|decodeURI|decodeURIComponent|String|","variable.language":"window|arguments|prototype|document"},"identifier"),a={token:["paren.lparen","variable.parameter","paren.rparen","text","storage.type"],regex:/(?:(\()((?:"[^")]*?"|'[^')]*?'|\/[^\/)]*?\/|[^()"'\/])*?)(\))(\s*))?([\-=]>)/.source},l=/\\(?:x[0-9a-fA-F]{2}|u[0-9a-fA-F]{4}|[0-2][0-7]{0,2}|3[0-6][0-7]?|37[0-7]?|[4-7][0-7]?|.)/;this.$rules={start:[{token:"constant.numeric",regex:"(?:0x[\\da-fA-F]+|(?:\\d+(?:\\.\\d+)?|\\.\\d+)(?:[eE][+-]?\\d+)?)"},{stateName:"qdoc",token:"string",regex:"'''",next:[{token:"string",regex:"'''",next:"start"},{token:"constant.language.escape",regex:l},{defaultToken:"string"}]},{stateName:"qqdoc",token:"string",regex:'"""',next:[{token:"string",regex:'"""',next:"start"},{token:"paren.string",regex:"#{",push:"start"},{token:"constant.language.escape",regex:l},{defaultToken:"string"}]},{stateName:"qstring",token:"string",regex:"'",next:[{token:"string",regex:"'",next:"start"},{token:"constant.language.escape",regex:l},{defaultToken:"string"}]},{stateName:"qqstring",token:"string.start",regex:'"',next:[{token:"string.end",regex:'"',next:"start"},{token:"paren.string",regex:"#{",push:"start"},{token:"constant.language.escape",regex:l},{defaultToken:"string"}]},{stateName:"js",token:"string",regex:"`",next:[{token:"string",regex:"`",next:"start"},{token:"constant.language.escape",regex:l},{defaultToken:"string"}]},{regex:"[{}]",onMatch:function(u,m,h){return this.next="","{"==u&&h.length?(h.unshift("start",m),"paren"):"}"==u&&h.length&&(h.shift(),this.next=h.shift()||"",-1!=this.next.indexOf("string"))?"paren.string":"paren"}},{token:"string.regex",regex:"///",next:"heregex"},{token:"string.regex",regex:/(?:\/(?![\s=])[^[\/\n\\]*(?:(?:\\[\s\S]|\[[^\]\n\\]*(?:\\[\s\S][^\]\n\\]*)*])[^[\/\n\\]*)*\/)(?:[imgy]{0,4})(?!\w)/},{token:"comment",regex:"###(?!#)",next:"comment"},{token:"comment",regex:"#.*"},{token:["punctuation.operator","text","identifier"],regex:"(\\.)(\\s*)("+e+")"},{token:"punctuation.operator",regex:"\\.{1,3}"},{token:["keyword","text","language.support.class","text","keyword","text","language.support.class"],regex:"(class)(\\s+)("+g+")(?:(\\s+)(extends)(\\s+)("+g+"))?"},{token:["entity.name.function","text","keyword.operator","text"].concat(a.token),regex:"("+g+")(\\s*)([=:])(\\s*)"+a.regex},a,{token:"variable",regex:"@(?:"+g+")?"},{token:r,regex:g},{token:"punctuation.operator",regex:"\\,|\\."},{token:"storage.type",regex:"[\\-=]>"},{token:"keyword.operator",regex:"(?:[-+*/%<>&|^!?=]=|>>>=?|\\-\\-|\\+\\+|::|&&=|\\|\\|=|<<=|>>=|\\?\\.|\\.{2,3}|[!*+-=><])"},{token:"paren.lparen",regex:"[({[]"},{token:"paren.rparen",regex:"[\\]})]"},{token:"text",regex:"\\s+"}],heregex:[{token:"string.regex",regex:".*?///[imgy]{0,4}",next:"start"},{token:"comment.regex",regex:"\\s+(?:#.*)?"},{token:"string.regex",regex:"\\S+"}],comment:[{token:"comment",regex:"###",next:"start"},{defaultToken:"comment"}]},this.normalizeRules()}p.inherits(c,f),x.CoffeeHighlightRules=c}),ace.define("ace/mode/matching_brace_outdent",["require","exports","module","ace/range"],function(o,x,k){"use strict";var p=o("../range").Range,f=function(){};(function(){this.checkOutdent=function(c,g){return!!/^\s+$/.test(c)&&/^\s*\}/.test(g)},this.autoOutdent=function(c,g){var d=c.getLine(g).match(/^(\s*\})/);if(!d)return 0;var e=d[1].length,s=c.findMatchingBracket({row:g,column:e});if(!s||s.row==g)return 0;var i=this.$getIndent(c.getLine(s.row));c.replace(new p(g,0,g,e-1),i)},this.$getIndent=function(c){return c.match(/^\s*/)[0]}}).call(f.prototype),x.MatchingBraceOutdent=f}),ace.define("ace/mode/folding/coffee",["require","exports","module","ace/lib/oop","ace/mode/folding/fold_mode","ace/range"],function(o,x,k){"use strict";var p=o("../../lib/oop"),f=o("./fold_mode").FoldMode,c=o("../../range").Range,g=x.FoldMode=function(){};p.inherits(g,f),function(){this.getFoldWidgetRange=function(t,d,e){var s=this.indentationBlock(t,e);if(s)return s;var i=/\S/,n=t.getLine(e),r=n.search(i);if(-1!=r&&"#"==n[r]){for(var a=n.length,l=t.getLength(),u=e,m=e;++e<l;){var h=(n=t.getLine(e)).search(i);if(-1!=h){if("#"!=n[h])break;m=e}}if(m>u){var v=t.getLine(m).length;return new c(u,a,m,v)}}},this.getFoldWidget=function(t,d,e){var s=t.getLine(e),i=s.search(/\S/),n=t.getLine(e+1),r=t.getLine(e-1),a=r.search(/\S/),l=n.search(/\S/);if(-1==i)return t.foldWidgets[e-1]=-1!=a&&a<l?"start":"","";if(-1==a){if(i==l&&"#"==s[i]&&"#"==n[i])return t.foldWidgets[e-1]="",t.foldWidgets[e+1]="","start"}else if(a==i&&"#"==s[i]&&"#"==r[i]&&-1==t.getLine(e-2).search(/\S/))return t.foldWidgets[e-1]="start",t.foldWidgets[e+1]="","";return t.foldWidgets[e-1]=-1!=a&&a<i?"start":"",i<l?"start":""}}.call(g.prototype)}),ace.define("ace/mode/coffee",["require","exports","module","ace/mode/coffee_highlight_rules","ace/mode/matching_brace_outdent","ace/mode/folding/coffee","ace/range","ace/mode/text","ace/worker/worker_client","ace/lib/oop"],function(o,x,k){"use strict";var p=o("./coffee_highlight_rules").CoffeeHighlightRules,f=o("./matching_brace_outdent").MatchingBraceOutdent,c=o("./folding/coffee").FoldMode,t=(o("../range"),o("./text").Mode),d=o("../worker/worker_client").WorkerClient;function s(){this.HighlightRules=p,this.$outdent=new f,this.foldingRules=new c}o("../lib/oop").inherits(s,t),function(){var i=/(?:[({[=:]|[-=]>|\b(?:else|try|(?:swi|ca)tch(?:\s+[$A-Za-z_\x7f-\uffff][$\w\x7f-\uffff]*)?|finally))\s*$|^\s*(else\b\s*)?(?:if|for|while|loop)\b(?!.*\bthen\b)/;this.lineCommentStart="#",this.blockComment={start:"###",end:"###"},this.getNextLineIndent=function(n,r,a){var l=this.$getIndent(r),u=this.getTokenizer().getLineTokens(r,n).tokens;return!(u.length&&"comment"===u[u.length-1].type)&&"start"===n&&i.test(r)&&(l+=a),l},this.checkOutdent=function(n,r,a){return this.$outdent.checkOutdent(r,a)},this.autoOutdent=function(n,r,a){this.$outdent.autoOutdent(r,a)},this.createWorker=function(n){var r=new d(["ace"],"ace/mode/coffee_worker","Worker");return r.attachToDocument(n.getDocument()),r.on("annotate",function(a){n.setAnnotations(a.data)}),r.on("terminate",function(){n.clearAnnotations()}),r},this.$id="ace/mode/coffee",this.snippetFileId="ace/snippets/coffee"}.call(s.prototype),x.Mode=s}),ace.require(["ace/mode/coffee"],function(o){"object"==typeof module&&"object"==typeof exports&&module&&(module.exports=o)});